# frozen_string_literal: true

desc 'Generate Wikidata rewritten queries'
named_task 'wikidata_rewritten_queries' do
  %w[minus star union].each do |template|
    Dir["wikidata/queries/#{template}/B/*.sparql"].each do |original_query|
      rewritten_query = original_query.sub('/B/', '/P/')
      FileUtils.mkdir_p(File.dirname(rewritten_query))
      sh "SPARQLprov/build/rewrite w #{original_query} > #{rewritten_query}"
    end
  end
end

desc 'Generate Wikidata rewritten queries'
task wikidata_rewritten_queries: task_dependency('wikidata_rewritten_queries')
